diff --git a/src/smallmap_gui.cpp b/src/smallmap_gui.cpp
--- a/src/smallmap_gui.cpp
+++ b/src/smallmap_gui.cpp
@@ -26,35 +26,44 @@
 #include "sound_func.h"
 #include "window_func.h"
 #include "company_base.h"
+//#include "cargotype.h"
+//#include "openttd.h"
+#include "company_func.h"
+#include "station_base.h"
 
 #include "table/strings.h"
 
+//#include <cmath>
+#include <vector>
+
 /** Widget numbers of the small map window. */
 enum SmallMapWindowWidgets {
 	SM_WIDGET_CAPTION,           ///< Caption widget.
 	SM_WIDGET_MAP_BORDER,        ///< Border around the smallmap.
 	SM_WIDGET_MAP,               ///< Panel containing the smallmap.
 	SM_WIDGET_LEGEND,            ///< Bottom panel to display smallmap legends.
+	SM_WIDGET_BLANK,             ///< Empty button as placeholder.
 	SM_WIDGET_ZOOM_IN,           ///< Button to zoom in one step.
 	SM_WIDGET_ZOOM_OUT,          ///< Button to zoom out one step.
 	SM_WIDGET_CONTOUR,           ///< Button to select the contour view (height map).
 	SM_WIDGET_VEHICLES,          ///< Button to select the vehicles view.
 	SM_WIDGET_INDUSTRIES,        ///< Button to select the industries view.
+	SM_WIDGET_LINKSTATS,         ///< Button to select the link stats view.
 	SM_WIDGET_ROUTES,            ///< Button to select the routes view.
 	SM_WIDGET_VEGETATION,        ///< Button to select the vegetation view.
 	SM_WIDGET_OWNERS,            ///< Button to select the owners view.
 	SM_WIDGET_CENTERMAP,         ///< Button to move smallmap center to main window center.
 	SM_WIDGET_TOGGLETOWNNAME,    ///< Toggle button to display town names.
 	SM_WIDGET_SELECT_BUTTONS,    ///< Selection widget for the buttons present in some smallmap modes.
-	SM_WIDGET_ENABLE_ALL,        ///< Button to enable display of all legend entries.
-	SM_WIDGET_DISABLE_ALL,       ///< Button to disable display of all legend entries.
+	SM_WIDGET_ENABLE_ALL,        ///< Button to enable display of all toggable legend entries.
+	SM_WIDGET_DISABLE_ALL,       ///< Button to disable display of all toggable legend entries.
 	SM_WIDGET_SHOW_HEIGHT,       ///< Show heightmap toggle button.
 };
 
-static int _smallmap_industry_count; ///< Number of used industries
-static int _smallmap_company_count;  ///< Number of entries in the owner legend.
-
+static int _smallmap_industry_count;         ///< Number of used industries
+static int _smallmap_company_count;          ///< Number of entries in the owner legend.
 static const int NUM_NO_COMPANY_ENTRIES = 4; ///< Number of entries in the owner legend that are not companies.
+static int _smallmap_cargo_count;            ///< number of cargos in the link stats legend
 
 static const uint8 PC_ROUGH_LAND      = 0x52; ///< Dark green palette colour for rough land.
 static const uint8 PC_GRASS_LAND      = 0x54; ///< Dark green palette colour for grass land.
@@ -63,27 +72,42 @@
 static const uint8 PC_TREES           = 0x57; ///< Green palette colour for trees.
 static const uint8 PC_WATER           = 0xCA; ///< Dark blue palette colour for water.
 
+enum SmallMapStats {
+	STAT_CAPACITY,
+	STAT_BEGIN = STAT_CAPACITY,
+	STAT_USAGE,
+	STAT_PLANNED,
+	STAT_SENT,
+	STAT_TEXT,
+	STAT_GRAPH,
+	STAT_END,
+	NUM_STATS = STAT_END,
+};
+
 /** Macro for ordinary entry of LegendAndColour */
 #define MK(a, b) {a, b, INVALID_INDUSTRYTYPE, 0, INVALID_COMPANY, true, false, false}
 
 /** Macro for a height legend entry with configurable colour. */
 #define MC(height)  {0, STR_TINY_BLACK_HEIGHT, INVALID_INDUSTRYTYPE, height, INVALID_COMPANY, true, false, false}
 
-/** Macro for non-company owned property entry of LegendAndColour */
-#define MO(a, b) {a, b, INVALID_INDUSTRYTYPE, 0, INVALID_COMPANY, true, false, false}
-
-/** Macro used for forcing a rebuild of the owner legend the first time it is used. */
-#define MOEND() {0, 0, INVALID_INDUSTRYTYPE, 0, OWNER_NONE, true, true, false}
-
-/** Macro for end of list marker in arrays of LegendAndColour */
-#define MKEND() {0, STR_NULL, INVALID_INDUSTRYTYPE, 0, INVALID_COMPANY, true, true, false}
-
 /**
  * Macro for break marker in arrays of LegendAndColour.
  * It will have valid data, though
  */
 #define MS(a, b) {a, b, INVALID_INDUSTRYTYPE, 0, INVALID_COMPANY, true, false, true}
 
+/** Macro for a height legend break marker entry with configurable colour. */
+#define MCS(height)  {0, STR_TINY_BLACK_HEIGHT, INVALID_INDUSTRYTYPE, height, INVALID_COMPANY, true, false, true}
+
+/** Macro for non-company owned property entry of LegendAndColour */
+#define MO(a, b) {a, b, INVALID_INDUSTRYTYPE, 0, INVALID_COMPANY, true, false, false}
+
+/** Macro used for forcing a rebuild of the owner legend the first time it is used. */
+#define MOEND() {0, 0, INVALID_INDUSTRYTYPE, 0, OWNER_NONE, true, true, false}
+
+/** Macro for end of list marker in arrays of LegendAndColour */
+#define MKEND() {0, STR_NULL, INVALID_INDUSTRYTYPE, 0, INVALID_COMPANY, true, true, false}
+
 /** Structure for holding relevant data for legends in small map */
 struct LegendAndColour {
 	uint8 colour;              ///< Colour of the item on the map.
@@ -96,14 +120,14 @@
 	bool col_break;            ///< Perform a column break and go further at the next column.
 };
 
-/** Legend text giving the colours to look for on the minimap */
-static LegendAndColour _legend_land_contours[] = {
-	/* The colours for the following values are set at BuildLandLegend() based on each colour scheme. */
-	MC(0),
-	MC(4),
-	MC(8),
-	MC(12),
-	MC(14),
+/** Legend text giving the colours to look for on the minimap (original) */
+static LegendAndColour _legend_land_contours_old[] = {
+	/* The colours for the following values are set at BuildLandLegend() based on each colour scheme when the more height levels patch is off. */
+	MC(1),
+	MC(5),
+	MC(9),
+	MC(13),
+	MC(15),
 
 	MS(PC_BLACK,           STR_SMALLMAP_LEGENDA_ROADS),
 	MK(PC_GREY,            STR_SMALLMAP_LEGENDA_RAILROADS),
@@ -113,6 +137,37 @@
 	MKEND()
 };
 
+/** Legend text giving the colours to look for on the minimap (in case of AllowMoreHeightlevels()) */
+static LegendAndColour _legend_land_contours_extended[] = {
+	/* The colours for the following values are set at BuildLandLegend() based on each colour scheme when the more height levels patch is on. */
+	MC(1),
+	MC(16),
+	MC(32),
+	MC(48),
+	MC(64),
+	MC(80),
+
+	MCS(96),
+	MC(112),
+	MC(128),
+	MC(144),
+	MC(160),
+	MC(176),
+
+	MCS(192),
+	MC(208),
+	MC(224),
+	MC(240),
+	MC(255),
+
+	MS(PC_BLACK,      STR_SMALLMAP_LEGENDA_ROADS),
+	MK(PC_GREY,       STR_SMALLMAP_LEGENDA_RAILROADS),
+	MK(PC_LIGHT_BLUE, STR_SMALLMAP_LEGENDA_STATIONS_AIRPORTS_DOCKS),
+	MK(PC_DARK_RED,   STR_SMALLMAP_LEGENDA_BUILDINGS_INDUSTRIES),
+	MK(PC_WHITE,      STR_SMALLMAP_LEGENDA_VEHICLES),
+	MKEND()
+};
+
 static const LegendAndColour _legend_vehicles[] = {
 	MK(PC_RED,             STR_SMALLMAP_LEGENDA_TRAINS),
 	MK(PC_YELLOW,          STR_SMALLMAP_LEGENDA_ROAD_VEHICLES),
@@ -165,6 +220,7 @@
 #undef MK
 #undef MC
 #undef MS
+#undef MCS
 #undef MO
 #undef MOEND
 #undef MKEND
@@ -212,10 +268,87 @@
 	_smallmap_industry_count = j;
 }
 
-static const LegendAndColour * const _legend_table[] = {
-	_legend_land_contours,
+static LegendAndColour _legend_linkstats[NUM_CARGO + NUM_STATS + 1];
+
+/**
+ * Populate legend table for the link stat view.
+ */
+void BuildLinkStatsLegend()
+{
+	/* Clear the legend */
+	memset(_legend_linkstats, 0, sizeof(_legend_linkstats));
+
+	uint i = 0;
+	for (; i < _sorted_cargo_specs_size; ++i) {
+		const CargoSpec *cs = _sorted_cargo_specs[i];
+
+		_legend_linkstats[i].legend = cs->name;
+		_legend_linkstats[i].colour = cs->legend_colour;
+		_legend_linkstats[i].type = cs->Index();
+		_legend_linkstats[i].show_on_map = true;
+	}
+
+	_legend_linkstats[i].col_break = true;
+
+	_smallmap_cargo_count = i;
+
+	/* the colours cannot be resolved before the gfx system is initialized.
+	 * So we have to build the legend when creating the window.
+	 */
+	for (uint st = 0; st < NUM_STATS; ++st) {
+		LegendAndColour & legend_entry = _legend_linkstats[i + st];
+		switch(st) {
+		case STAT_CAPACITY:
+			legend_entry.colour = _colour_gradient[COLOUR_WHITE][7];
+			legend_entry.legend = STR_SMALLMAP_LEGENDA_CAPACITY;
+			legend_entry.show_on_map = true;
+			break;
+		case STAT_USAGE:
+			legend_entry.colour = _colour_gradient[COLOUR_GREY][1];
+			legend_entry.legend = STR_SMALLMAP_LEGENDA_USAGE;
+			legend_entry.show_on_map = false;
+			break;
+		case STAT_PLANNED:
+			legend_entry.colour = _colour_gradient[COLOUR_RED][5];
+			legend_entry.legend = STR_SMALLMAP_LEGENDA_PLANNED;
+			legend_entry.show_on_map = true;
+			break;
+		case STAT_SENT:
+			legend_entry.colour = _colour_gradient[COLOUR_YELLOW][5];
+			legend_entry.legend = STR_SMALLMAP_LEGENDA_SENT;
+			legend_entry.show_on_map = false;
+			break;
+		case STAT_TEXT:
+			legend_entry.colour = _colour_gradient[COLOUR_GREY][7];
+			legend_entry.legend = STR_SMALLMAP_LEGENDA_SHOW_TEXT;
+			legend_entry.show_on_map = false;
+			break;
+		case STAT_GRAPH:
+			legend_entry.colour = _colour_gradient[COLOUR_GREY][7];
+			legend_entry.legend = STR_SMALLMAP_LEGENDA_SHOW_GRAPH;
+			legend_entry.show_on_map = true;
+			break;
+		}
+	}
+
+	_legend_linkstats[i + NUM_STATS].end = true;
+}
+
+static const LegendAndColour * const _legend_table_old[] = {
+	_legend_land_contours_old,
 	_legend_vehicles,
 	_legend_from_industries,
+	_legend_linkstats,
+	_legend_routes,
+	_legend_vegetation,
+	_legend_land_owners,
+};
+
+static const LegendAndColour * const _legend_table_extended[] = {
+	_legend_land_contours_extended,
+	_legend_vehicles,
+	_legend_from_industries,
+	_legend_linkstats,
 	_legend_routes,
 	_legend_vegetation,
 	_legend_land_owners,
@@ -237,8 +370,12 @@
 #define MKCOLOUR_F00F       MKCOLOUR_X00X(0xFF)
 #define MKCOLOUR_FFFF       MKCOLOUR_XXXX(0xFF)
 
-/** Height map colours for the green colour scheme, ordered by height. */
-static const uint32 _green_map_heights[] = {
+/**
+ * Colour array for displaying elevation in the smallmap, ordered by height.
+ * This is the original array for use when AllowMoreHeightlevels() is false.
+ */
+static const uint32 _green_map_heights_old[] = {
+	MKCOLOUR(0x04dcdcdc), // Action colour, flashing purple. This is for level zero(Not flooded) !! Flooding danger !! Not yet water. (When level -1 will be possible: Will provide for a nice flooding_danger_area_border_flash in combination witch previous colour, similar to the waves at water borders.)
 	MKCOLOUR_XXXX(0x5A),
 	MKCOLOUR_XYXY(0x5A, 0x5B),
 	MKCOLOUR_XXXX(0x5B),
@@ -256,10 +393,288 @@
 	MKCOLOUR_XXXX(0x27),
 	MKCOLOUR_XXXX(0x27),
 };
-assert_compile(lengthof(_green_map_heights) == MAX_TILE_HEIGHT + 1);
-
-/** Height map colours for the dark green colour scheme, ordered by height. */
-static const uint32 _dark_green_map_heights[] = {
+assert_compile(lengthof(_green_map_heights_old) == MAX_TILE_HEIGHT_OLD + 2);
+
+/**
+ * Height map colours for the green colour scheme, ordered by height.
+ * Used when AllowMoreHeightlevels() is true.
+ * For the moment the aray is extended to 256 levels.
+ */
+static const uint32 _green_map_heights_extended[] = {
+	/* First two colours are action colours.(First commented out, first we need level -1 (and underwater tunnels)) */
+	//MKCOLOUR(0xdcdcdcdc), // Nice flashy colour, darkblue. (Do not use above level 1. (second colour)) (I keep it here to become level -1 ground tile (not flooded) (For now: To see its full effect, use this as second color.Then imagine at level -1.))
+	MKCOLOUR(0x04dcdcdc), // Action colour, flashing purple. This is for level zero(Not flooded) !! Flooding danger !! Not yet water. (When level -1 will be possible: Will provide for a nice flooding_danger_area_border_flash in combination witch previous colour, similar to the waves at water borders.)
+	MKCOLOUR(0x59595958), // height 1
+	MKCOLOUR(0x59595958), // height 2
+	MKCOLOUR(0X59595959), // height 3
+	MKCOLOUR(0X59595959), // height 4
+	MKCOLOUR(0X5959595A), // height 5
+	MKCOLOUR(0X5959595A), // height 6
+	MKCOLOUR(0X59595A59), // height 7
+	MKCOLOUR(0X59595A59), // height 8
+	MKCOLOUR(0X59595A5A), // height 9
+	MKCOLOUR(0X59595A5A), // height 10
+	MKCOLOUR(0X595A5959), // height 11
+	MKCOLOUR(0X595A5959), // height 12
+	MKCOLOUR(0X595A595A), // height 13
+	MKCOLOUR(0X595A595A), // height 14
+	MKCOLOUR(0X595A5A59), // height 15
+	MKCOLOUR(0X595A5A59), // height 16
+	MKCOLOUR(0X595A5A5A), // height 17
+	MKCOLOUR(0X595A5A5A), // height 18
+	MKCOLOUR(0X5A595959), // height 19
+	MKCOLOUR(0X5A595959), // height 20
+	MKCOLOUR(0X5A59595A), // height 21
+	MKCOLOUR(0X5A59595A), // height 22
+	MKCOLOUR(0X5A595A59), // height 23
+	MKCOLOUR(0X5A595A59), // height 24
+	MKCOLOUR(0X5A595A5A), // height 25
+	MKCOLOUR(0X5A595A5A), // height 26
+	MKCOLOUR(0X5A5A5959), // height 27
+	MKCOLOUR(0X5A5A5959), // height 28
+	MKCOLOUR(0X5A5A595A), // height 29
+	MKCOLOUR(0X5A5A595A), // height 30
+	MKCOLOUR(0X5A5A5A59), // height 31
+	MKCOLOUR(0X5A5A5A59), // height 32
+	MKCOLOUR(0x5A5A5A5A), // height 33 // original smallmap color do not modify
+	MKCOLOUR(0x5A5A5A5A), // height 34 // original smallmap color do not modify
+	MKCOLOUR(0x5A5A5A5B), // height 35
+	MKCOLOUR(0x5A5A5A5B), // height 36
+	MKCOLOUR(0x5A5A5B5A), // height 37
+	MKCOLOUR(0x5A5A5B5A), // height 38
+	MKCOLOUR(0x5A5A5B5B), // height 39
+	MKCOLOUR(0x5A5A5B5B), // height 40
+	MKCOLOUR(0x5A5B5A5A), // height 41
+	MKCOLOUR(0x5A5B5A5A), // height 42
+	MKCOLOUR(0x5A5B5A5B), // height 43 // original smallmap color do not modify
+	MKCOLOUR(0x5A5B5A5B), // height 44 // original smallmap color do not modify
+	MKCOLOUR(0x5A5B5B5A), // height 45
+	MKCOLOUR(0x5A5B5B5A), // height 46
+	MKCOLOUR(0x5A5B5B5B), // height 47
+	MKCOLOUR(0x5A5B5B5B), // height 48
+	MKCOLOUR(0x5B5A5A5A), // height 49
+	MKCOLOUR(0x5B5A5A5A), // height 50
+	MKCOLOUR(0x5B5A5A5B), // height 51
+	MKCOLOUR(0x5B5A5A5B), // height 52
+	MKCOLOUR(0x5B5A5B5A), // height 53
+	MKCOLOUR(0x5B5A5B5A), // height 54
+	MKCOLOUR(0x5B5A5B5B), // height 55
+	MKCOLOUR(0x5B5A5B5B), // height 56
+	MKCOLOUR(0x5B5B5A5A), // height 57
+	MKCOLOUR(0x5B5B5A5A), // height 58
+	MKCOLOUR(0x5B5B5A5B), // height 59
+	MKCOLOUR(0x5B5B5A5B), // height 60
+	MKCOLOUR(0x5B5B5B5B), // height 61 // original smallmap color do not modify
+	MKCOLOUR(0x5B5B5B5B), // height 62 // original smallmap color do not modify
+	MKCOLOUR(0x5B5B5B5C), // height 63
+	MKCOLOUR(0x5B5B5B5C), // height 64
+	MKCOLOUR(0x5B5B5C5B), // height 65
+	MKCOLOUR(0x5B5B5C5B), // height 66
+	MKCOLOUR(0x5B5B5C5C), // height 67
+	MKCOLOUR(0x5B5B5C5C), // height 68
+	MKCOLOUR(0x5B5C5B5B), // height 69
+	MKCOLOUR(0x5B5C5B5B), // height 70
+	MKCOLOUR(0x5B5C5B5C), // height 71 // original smallmap color do not modify
+	MKCOLOUR(0x5B5C5B5C), // height 72 // original smallmap color do not modify
+	MKCOLOUR(0x5B5C5C5B), // height 73
+	MKCOLOUR(0x5B5C5C5B), // height 74
+	MKCOLOUR(0x5B5C5C5C), // height 75
+	MKCOLOUR(0x5B5C5C5C), // height 76
+	MKCOLOUR(0x5C5B5B5B), // height 77
+	MKCOLOUR(0x5C5B5B5B), // height 78
+	MKCOLOUR(0x5C5B5B5C), // height 79
+	MKCOLOUR(0x5C5B5B5C), // height 80
+	MKCOLOUR(0x5C5B5C5B), // height 81
+	MKCOLOUR(0x5C5B5C5B), // height 82
+	MKCOLOUR(0x5C5B5C5C), // height 83
+	MKCOLOUR(0x5C5B5C5C), // height 84
+	MKCOLOUR(0x5C5C5B5B), // height 85
+	MKCOLOUR(0x5C5C5B5B), // height 86
+	MKCOLOUR(0x5C5C5B5C), // height 87
+	MKCOLOUR(0x5C5C5B5C), // height 88
+	MKCOLOUR(0x5C5C5C5C), // height 89 // original smallmap color do not modify
+	MKCOLOUR(0x5C5C5C5C), // height 90 // original smallmap color do not modify
+	MKCOLOUR(0x5C5C5C5D), // height 91
+	MKCOLOUR(0x5C5C5C5D), // height 92
+	MKCOLOUR(0x5C5C5D5C), // height 93
+	MKCOLOUR(0x5C5C5D5C), // height 94
+	MKCOLOUR(0x5C5C5D5D), // height 95
+	MKCOLOUR(0x5C5C5D5D), // height 96
+	MKCOLOUR(0x5C5D5C5C), // height 97
+	MKCOLOUR(0x5C5D5C5C), // height 98
+	MKCOLOUR(0x5C5D5C5D), // height 99 // original smallmap color do not modify
+	MKCOLOUR(0x5C5D5C5D), // height 100 // original smallmap color do not modify
+	MKCOLOUR(0x5C5D5D5C), // height 101
+	MKCOLOUR(0x5C5D5D5C), // height 102
+	MKCOLOUR(0x5C5D5D5D), // height 103
+	MKCOLOUR(0x5C5D5D5D), // height 104
+	MKCOLOUR(0x5D5C5C5C), // height 105
+	MKCOLOUR(0x5D5C5C5C), // height 106
+	MKCOLOUR(0x5D5C5C5D), // height 107
+	MKCOLOUR(0x5D5C5C5D), // height 108
+	MKCOLOUR(0x5D5C5D5C), // height 109
+	MKCOLOUR(0x5D5C5D5C), // height 110
+	MKCOLOUR(0x5D5C5D5D), // height 111
+	MKCOLOUR(0x5D5C5D5D), // height 112
+	MKCOLOUR(0x5D5D5C5C), // height 113
+	MKCOLOUR(0x5D5D5C5C), // height 114
+	MKCOLOUR(0x5D5D5C5D), // height 115
+	MKCOLOUR(0x5D5D5C5D), // height 116
+	MKCOLOUR(0x5D5D5D5D), // height 117 // original smallmap color do not modify
+	MKCOLOUR(0x5D5D5D5D), // height 118 // original smallmap color do not modify
+	MKCOLOUR(0x5D5D5D5E), // height 119
+	MKCOLOUR(0x5D5D5D5E), // height 120
+	MKCOLOUR(0x5D5D5E5D), // height 121
+	MKCOLOUR(0x5D5D5E5D), // height 122
+	MKCOLOUR(0x5D5D5E5E), // height 123
+	MKCOLOUR(0x5D5D5E5E), // height 124
+	MKCOLOUR(0x5D5E5D5D), // height 125
+	MKCOLOUR(0x5D5E5D5D), // height 126
+	MKCOLOUR(0x5D5E5D5E), // height 127 // original smallmap color do not modify
+	MKCOLOUR(0x5D5E5D5E), // height 128 // original smallmap color do not modify
+	MKCOLOUR(0x5D5E5E5D), // height 129
+	MKCOLOUR(0x5D5E5E5D), // height 130
+	MKCOLOUR(0x5D5E5E5E), // height 131
+	MKCOLOUR(0x5D5E5E5E), // height 132
+	MKCOLOUR(0x5E5D5D5D), // height 133
+	MKCOLOUR(0x5E5D5D5D), // height 134
+	MKCOLOUR(0x5E5D5D5E), // height 135
+	MKCOLOUR(0x5E5D5D5E), // height 136
+	MKCOLOUR(0x5E5D5E5D), // height 137
+	MKCOLOUR(0x5E5D5E5D), // height 138
+	MKCOLOUR(0x5E5D5E5E), // height 139
+	MKCOLOUR(0x5E5D5E5E), // height 140
+	MKCOLOUR(0x5E5D5D5D), // height 141
+	MKCOLOUR(0x5E5D5D5D), // height 142
+	MKCOLOUR(0x5E5D5D5E), // height 143
+	MKCOLOUR(0x5E5D5D5E), // height 144
+	MKCOLOUR(0x5E5E5E5E), // height 145 // original smallmap color do not modify
+	MKCOLOUR(0x5E5E5E5E), // height 146 // original smallmap color do not modify
+	MKCOLOUR(0x5E5E5E5F), // height 147
+	MKCOLOUR(0x5E5E5E5F), // height 148
+	MKCOLOUR(0x5E5E5F5E), // height 149
+	MKCOLOUR(0x5E5E5F5E), // height 150
+	MKCOLOUR(0x5E5E5F5F), // height 151
+	MKCOLOUR(0x5E5E5F5F), // height 152
+	MKCOLOUR(0x5E5F5E5E), // height 153
+	MKCOLOUR(0x5E5F5E5E), // height 154
+	MKCOLOUR(0x5E5F5E5F), // height 155 // original smallmap color do not modify
+	MKCOLOUR(0x5E5F5E5F), // height 156 // original smallmap color do not modify
+	MKCOLOUR(0x5E5F5F5E), // height 157
+	MKCOLOUR(0x5E5F5F5E), // height 158
+	MKCOLOUR(0x5E5F5F5F), // height 159
+	MKCOLOUR(0x5E5F5F5F), // height 160
+	MKCOLOUR(0x5F5E5E5E), // height 161
+	MKCOLOUR(0x5F5E5E5E), // height 162
+	MKCOLOUR(0x5F5E5E5F), // height 163
+	MKCOLOUR(0x5F5E5E5F), // height 164
+	MKCOLOUR(0x5F5E5F5E), // height 165
+	MKCOLOUR(0x5F5E5F5E), // height 166
+	MKCOLOUR(0x5F5E5F5F), // height 167
+	MKCOLOUR(0x5F5E5F5F), // height 168
+	MKCOLOUR(0x5F5F5E5E), // height 169
+	MKCOLOUR(0x5F5F5E5E), // height 170
+	MKCOLOUR(0x5F5F5E5F), // height 171
+	MKCOLOUR(0x5F5F5E5F), // height 172
+	MKCOLOUR(0x5F5F5F5F), // height 173 // original smallmap color do not modify
+	MKCOLOUR(0x5F5F5F5F), // height 174 // original smallmap color do not modify
+	MKCOLOUR(0x5F5F5F1F), // height 175
+	MKCOLOUR(0x5F5F5F1F), // height 176
+	MKCOLOUR(0x5F5F1F5F), // height 177
+	MKCOLOUR(0x5F5F1F5F), // height 178
+	MKCOLOUR(0x5F5F1F1F), // height 179
+	MKCOLOUR(0x5F5F1F1F), // height 180
+	MKCOLOUR(0x5F1F5F1F), // height 181 // original smallmap color do not modify
+	MKCOLOUR(0x5F1F5F1F), // height 182 // original smallmap color do not modify
+// pale greens need finetuning ?
+	MKCOLOUR(0x5F1F1F1F), // height 183
+	MKCOLOUR(0x5F1F1F1F), // height 184
+	MKCOLOUR(0x1F5F5F5F), // height 185
+	MKCOLOUR(0x1F5F5F5F), // height 186
+	MKCOLOUR(0x1F5F5F1F), // height 187
+	MKCOLOUR(0x1F5F5F1F), // height 188
+	MKCOLOUR(0x1F5F1F5F), // height 189
+	MKCOLOUR(0x1F5F1F5F), // height 190
+	MKCOLOUR(0x1F5F1F1F), // height 191
+	MKCOLOUR(0x1F5F1F1F), // height 192
+	MKCOLOUR(0x1F1F5F5F), // height 193
+	MKCOLOUR(0x1F1F5F5F), // height 194
+	MKCOLOUR(0x1F1F5F1F), // height 195
+	MKCOLOUR(0x1F1F5F1F), // height 196
+	MKCOLOUR(0x1F1F1F5F), // height 197
+	MKCOLOUR(0x1F1F1F5F), // height 198
+//fine tune pale greens untill here ?
+	MKCOLOUR(0x1F1F1F1F), // height 199 // original smallmap color do not modify
+	MKCOLOUR(0x1F1F1F1F), // height 200 // original smallmap color do not modify
+	MKCOLOUR(0x1F1F1F27), // height 201
+	MKCOLOUR(0x1F1F1F27), // height 202
+	MKCOLOUR(0x1F1F271F), // height 203
+	MKCOLOUR(0x1F1F271F), // height 204
+	MKCOLOUR(0x1F1F2727), // height 205
+	MKCOLOUR(0x1F1F2727), // height 206
+	MKCOLOUR(0x1F271F1F), // height 207
+	MKCOLOUR(0x1F271F1F), // height 208
+	MKCOLOUR(0x1F271F27), // height 209 // original smallmap color do not modify
+	MKCOLOUR(0x1F271F27), // height 210 // original smallmap color do not modify
+	MKCOLOUR(0x1F272727), // height 211
+	MKCOLOUR(0x1F272727), // height 212
+	MKCOLOUR(0x271F1F1F), // height 213
+	MKCOLOUR(0x271F1F1F), // height 214
+	MKCOLOUR(0x271F1F27), // height 215
+	MKCOLOUR(0x271F1F27), // height 216
+	MKCOLOUR(0x271F271F), // height 217
+	MKCOLOUR(0x271F271F), // height 218
+	MKCOLOUR(0x271F2727), // height 219
+	MKCOLOUR(0x271F2727), // height 220
+	MKCOLOUR(0x27271F1F), // height 221
+	MKCOLOUR(0x27271F1F), // height 222
+	MKCOLOUR(0x27271F27), // height 223
+	MKCOLOUR(0x27271F27), // height 224
+	MKCOLOUR(0x2727271F), // height 225
+	MKCOLOUR(0x2727271F), // height 226
+	MKCOLOUR(0x27272727), // height 227 // original smallmap color do not modify
+	MKCOLOUR(0x27272727), // height 228 // original smallmap color do not modify
+    /* Above and below the same color. I know. It was like that before I arrived. I prefer extending over modifying, it stays. */
+	MKCOLOUR(0x27272727), // height 229 // original smallmap color do not modify
+	MKCOLOUR(0x27272727), // height 230 // original smallmap color do not modify
+	/* Purple top */
+	MKCOLOUR(0x1F27AF27), // height 231
+	MKCOLOUR(0x1F27AF27), // height 232
+	MKCOLOUR(0x1F274FAF), // height 233
+	MKCOLOUR(0x1F274FAF), // height 234
+	MKCOLOUR(0x4F274FAF), // height 235
+	MKCOLOUR(0x4F274FAF), // height 236
+	MKCOLOUR(0x4FAF1FAF), // height 237
+	MKCOLOUR(0x4FAF1FAF), // height 238
+	MKCOLOUR(0x4F2727AF), // height 239
+	MKCOLOUR(0x4F2727AF), // height 240
+	MKCOLOUR(0x4F27AF27), // height 241
+	MKCOLOUR(0x4F27AF27), // height 242
+	MKCOLOUR(0x4F27AFAF), // height 243
+	MKCOLOUR(0x4F27AFAF), // height 244
+	MKCOLOUR(0x4FAF2727), // height 245
+	MKCOLOUR(0x4FAF2727), // height 246
+	MKCOLOUR(0x4FAF27AF), // height 247
+	MKCOLOUR(0x4FAF27AF), // height 248
+	MKCOLOUR(0x4FAFAF27), // height 249
+	MKCOLOUR(0x4FAFAF27), // height 250
+	MKCOLOUR(0x4FAFAFAF), // height 251
+	MKCOLOUR(0x4FAFAFAF), // height 252
+	MKCOLOUR(0x4FAFAFCF), // height 253
+	MKCOLOUR(0x4FAFAFCF), // height 254
+	MKCOLOUR(0x4FAFCFAF), // height 255
+	MKCOLOUR(0x4FCFAFAF), /* 1 extra color for people not liking the flood_warning feature. */
+	/* Flashing test with current parameters no longer needed. */
+	//MKCOLOUR(0x04dcdcdc), /* FLASHING TEST (You can use this when going for 512 colours.) */
+};
+assert_compile(lengthof(_green_map_heights_extended) == MAX_TILE_HEIGHT_EXTENDED + 2);
+
+/**
+ * Height map colours for the dark green colour scheme, ordered by height.
+ * This is the original array for use when AllowMoreHeightlevels() is false.
+ */
+static const uint32 _dark_green_map_heights_old[] = {
+	MKCOLOUR(0x04dcdcdc), // Action colour, flashing purple. This is for level zero(Not flooded) !! Flooding danger !! Not yet water. (When level -1 will be possible: Will provide for a nice flooding_danger_area_border_flash in combination witch previous colour, similar to the waves at water borders.)
 	MKCOLOUR_XXXX(0x60),
 	MKCOLOUR_XYXY(0x60, 0x61),
 	MKCOLOUR_XXXX(0x61),
